% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/algorithms.R
\name{setOmpThreads}
\alias{setOmpThreads}
\title{Control OpenMP thread count}
\usage{
setOmpThreads(threads)
}
\arguments{
\item{threads}{Number of threads to use.}
}
\value{
Invisible \code{NULL}.
}
\description{
The method executes the \code{omp_set_num_threads} function, allowing to override the number of threads spawned by the later executed OpenMP code, including the praznik filters.
By default, all the logical cores will be used, thus this function is only useful to limit this number.
}
\note{
This function is the same as provided by the \code{OpenMPController} package.
You can also control OpenMP code by using environment variables, in particular \code{OMP_NUM_THREADS}.
}
